<template>
  <div id="root">
    <div class="userType" v-if="!output">
      <span class="path">{{ path }}</span>
      <input
        spellcheck="false"
        ref="commandInput"
        type="text"
        v-model="command"
        @keydown.enter.prevent.exact="runCommand"
        @keydown.prevent.exact="writeCommand"
        @keydown.left.exact="left"
        @keydown.ctrl.left.exact="ctrlLeft"
        @keydown.right.exact="right"
        @keydown.ctrl.right.exact="ctrlRight"
        @keydown.delete.prevent.exact="remove"
      />
      <span class="caret" :style="caretPos()" />
    </div>
    <div class="outpuType" v-if="output">
      <pre ref="commandInput">{{ command }}</pre>
      <span class="caret" :style="caretPos()" />
    </div>
  </div>
</template>

<script lang="ts">
import { Component, Prop, Vue, PropSync } from "vue-property-decorator";

@Component
export default class Input extends Vue {
  output = false;
  cmdList!: { [cmd: string]: any };
  resume!: { [cmd: string]: any };
  preload = ["WELCOME TO MY RESUME", "this is SAEED AMIN"];
  command: string = "personal-info";
  caretOffset: number = this.command.length;

  @Prop()
  private path!: string;

  @PropSync("history", { type: Array }) historyCmd!: Object[];

  async mounted() {
    this.getCmdList();
    this.getResume();
    // await this.welcome();
    this.setFocus();
    // this.command= "skill -a"
  }

  async welcome(): Promise<boolean> {
    this.output = true;
    for (let j = 0; j < this.preload.length; j++) {
      await this.outputTyping(this.preload[j], false);
    }
    this.output = false;

    return new Promise((done) => done(true));
  }

  getCmdList() {
    fetch("/commands.json")
      .then((r) => r.json())
      .then((cmds) => {
        console.log({ cmds });
        this.cmdList = cmds;
      });
  }

  getResume() {
    fetch("/resume.json")
      .then((r) => r.json())
      .then((resume) => {
        console.log({ resume });
        this.resume = resume;
      });
  }

  addHistory(pathStatus: boolean = true) {
    this.historyCmd.push({ path: pathStatus, cmd: this.command });
    this.command = "";
    this.caretOffset = 0;
  }

  runCommand() {
    this.cmdFunc(this.command);
  }

  async cmdFunc(cmdTxt: string) {
    let cmd = this.getCmdObj(cmdTxt);
    this.addHistory(true);
    let info = this.resume[cmd.map];
    let l = 0;
    if (typeof info == "object" && cmd.cmd !== "help") {
      for (const key in info) {
        if (key.length > l) l = key.length;
      }
      l += 4;
      info = { ...info };
      this.output = true;
      let whiteSpace = " ";
      for (const key in info) {
        whiteSpace = this.getWhiteSpace(l - key.length);
        await this.outputTyping(key + whiteSpace + info[key], false);
      }
      this.output = false;
    } else {
      this.command = cmd.origin + ": comand not found";
      this.addHistory(false);

      this.command = `${cmd.cmd}: ${cmd.desc}`;
      this.addHistory(false);
    }
  }

  getWhiteSpace(n: number) {
    let s = " ";
    for (let j = 0; j < n; j++) {
      s += " ";
    }
    return s;
  }

  runHelp(cmd: string = "") {
    if (cmd.length) {
      return this.cmdList[cmd].help.desc;
    } else {
      return this.cmdList.help.desc;
    }
  }

  getCmdObj(cmdLine: string) {
    // eslint-disable-next-line
    let regex = /(\w+\-*\w+)(?:\s+(-\w)?\s*(\w+)?.*){0,1}/g;
    let cmdArr = regex.exec(cmdLine) || ["", "", "", ""];
    let origin = cmdArr[1];
    let cmd = cmdArr[1];
    let option = cmdArr[2];
    let rest = cmdArr[3];
    let map = "";
    let desc = "";
    let cmdObj = { cmd, option, rest, map, desc, origin };
    console.log({ cmdArr, cmdObj });

    // the command not found
    if (!this.cmdList[cmd]) {
      cmdObj.cmd = "help";
      cmdObj.option = "";
      cmdObj.rest = "";
      cmdObj.map = "";
      cmdObj.desc = this.cmdList["help"].desc;
      return cmdObj;
    }
    cmdObj.map = this.cmdList[cmd].map;

    if (option) {
      let o = this.cmdList[cmd].options[option];
      if (!o) {
        cmdObj.option = "";
        cmdObj.rest = "help";
        cmdObj.map = "";
        return cmdObj;
      }
      cmdObj.option = o;
    }

    return cmdObj;
  }

  writeCommand(e: any) {
    if (
      e.keyCode == 32 ||
      e.keyCode == 189 ||
      (e.keyCode >= 48 && e.keyCode <= 90)
    ) {
      let strArr = [...this.command];
      strArr.splice(this.caretOffset, 0, e.key);
      this.command = strArr.join("");
      this.caretOffset++;
    }
  }

  caretPos() {
    return { left: this.caretOffset * 9.6 + "px" };
  }

  left() {
    this.caretOffset = this.caretOffset > 0 ? --this.caretOffset : 0;
  }
  ctrlLeft() {
    this.caretOffset = 0;
  }
  right() {
    this.caretOffset =
      this.caretOffset < this.command.length
        ? ++this.caretOffset
        : this.command.length;
  }
  ctrlRight() {
    this.caretOffset = this.command.length;
  }
  remove(c: any) {
    if (c.key == "Backspace") {
      let strArr = [...this.command];
      this.left();
      strArr.splice(this.caretOffset, 1);
      this.command = strArr.join("");
    } else {
      let strArr = [...this.command];
      strArr.splice(this.caretOffset, 1);
      this.command = strArr.join("");
    }
  }

  setFocus() {
    (this.$refs.commandInput as HTMLElement).focus();
  }

  sleep(ms: number) {
    return new Promise((resolve) => setTimeout(resolve, ms));
  }

  outputTyping(str: string, path: boolean) {
    const strArr = str.match(/[^\s]|(\s*)/g);

    this.command = "";
    this.caretOffset = 0;

    if (strArr === null) return null;
    const timer = async (): Promise<boolean> => {
      for (let i = 0; i < strArr.length; i++) {
        this.command += strArr[i];
        this.caretOffset += strArr[i].length;
        await this.sleep(70);
      }
      this.addHistory(path);
      return new Promise((done) => done(true));
    };
    return timer();
  }
}
</script>

<style lang="scss" scoped>
#root {
  position: relative;
}

.userType {
  display: flex;
  position: relative;
  margin-left: 200px;

  .path {
    position: absolute;
    left: -200px;
  }
  input {
    background-color: transparent;
    border: none;
    flex: 1;
    margin: 0 -10px 0 0;
    padding: 0 10px 0 0;
    caret-color: transparent;
    &:focus {
      outline: none;
    }
  }
}

pre {
  margin-top: 0;
}

.caret {
  display: inline-block;
  position: absolute;
  bottom: 1px;
  left: 0;
  height: 1px;
  animation: blinker 0.8s linear infinite;
  border-top: solid #4da361 3px;
  &::before {
    content: "a";
    color: transparent;
  }
}

@keyframes blinker {
  0% {
    opacity: 1;
  }
  19% {
    opacity: 1;
  }
  20% {
    opacity: 0;
  }
  79% {
    opacity: 0;
  }
  80% {
    opacity: 1;
  }
  100% {
    opacity: 1;
  }
}
</style>
